RDKit: RDKit::MorganFingerprint Namespace Reference

| RDKit Open-source cheminformatics and machine learning.

Loading...
Searching...
No Matches
Classes | Functions
RDKit::MorganFingerprint Namespace Reference

## Classes
class | MorganArguments
| Class for holding Morgan fingerprint specific arguments. More...
class | MorganAtomEnv
| Class for holding the bit-id created from Morgan fingerprint environments and the additional data necessary extra outputs. More...
class | MorganAtomInvGenerator
| Default atom invariants generator for Morgan fingerprint, generates ECFP-type invariants. More...
class | MorganBondInvGenerator
| Bond invariants generator for Morgan fingerprint. More...
class | MorganEnvGenerator
| Class that generates atom environments for Morgan fingerprint. More...
class | MorganFeatureAtomInvGenerator
| Alternative atom invariants generator for Morgan fingerprint, generate FCFP-type invariants. More...

## Functions
template<typename OutputType>
RDKIT_FINGERPRINTS_EXPORT FingerprintGenerator< OutputType > * | getMorganGenerator (unsigned int radius, bool countSimulation, bool includeChirality, bool useBondTypes, bool onlyNonzeroInvariants, bool includeRedundantEnvironments, AtomInvariantsGenerator *atomInvariantsGenerator=nullptr, BondInvariantsGenerator *bondInvariantsGenerator=nullptr, std::uint32_t fpSize=2048, std::vector< std::uint32_t > countBounds={1, 2, 4, 8}, bool ownsAtomInvGen=false, bool ownsBondInvGen=false)
| Get a fingerprint generator for Morgan fingerprint.
template<typename OutputType>
RDKIT_FINGERPRINTS_EXPORT FingerprintGenerator< OutputType > * | getMorganGenerator (const MorganArguments &args, AtomInvariantsGenerator *atomInvariantsGenerator=nullptr, BondInvariantsGenerator *bondInvariantsGenerator=nullptr, bool ownsAtomInvGen=false, bool ownsBondInvGen=false)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<typename OutputType>
FingerprintGenerator< OutputType > * | getMorganGenerator (unsigned int radius, bool countSimulation=false, bool includeChirality=false, bool useBondTypes=true, bool onlyNonzeroInvariants=false, AtomInvariantsGenerator *atomInvariantsGenerator=nullptr, BondInvariantsGenerator *bondInvariantsGenerator=nullptr, std::uint32_t fpSize=2048, std::vector< std::uint32_t > countBounds={1, 2, 4, 8}, bool ownsAtomInvGen=false, bool ownsBondInvGen=false)
| Get a fingerprint generator for Morgan fingerprint.

## Function Documentation

## ◆ getMorganGenerator() [1/3]

template<typename OutputType>

RDKIT_FINGERPRINTS_EXPORT FingerprintGenerator< OutputType > * RDKit::MorganFingerprint::getMorganGenerator | ( | const MorganArguments & | args,
|  | AtomInvariantsGenerator * | atomInvariantsGenerator = nullptr,
|  | BondInvariantsGenerator * | bondInvariantsGenerator = nullptr,
|  | bool | ownsAtomInvGen = false,
|  | bool | ownsBondInvGen = false )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References RDKIT_FINGERPRINTS_EXPORT.

## ◆ getMorganGenerator() [2/3]

template<typename OutputType>

RDKIT_FINGERPRINTS_EXPORT FingerprintGenerator< OutputType > * RDKit::MorganFingerprint::getMorganGenerator | ( | unsigned int | radius,
|  | bool | countSimulation,
|  | bool | includeChirality,
|  | bool | useBondTypes,
|  | bool | onlyNonzeroInvariants,
|  | bool | includeRedundantEnvironments,
|  | AtomInvariantsGenerator * | atomInvariantsGenerator = nullptr,
|  | BondInvariantsGenerator * | bondInvariantsGenerator = nullptr,
|  | std::uint32_t | fpSize = 2048,
|  | std::vector< std::uint32_t > | countBounds = {1, 2, 4, 8},
|  | bool | ownsAtomInvGen = false,
|  | bool | ownsBondInvGen = false )

Get a fingerprint generator for Morgan fingerprint.

Template Parameters

  OutputType | determines the size of the bitIds and the result, can be 32 or 64 bit unsigned integer

Parameters

  radius | the number of iterations to grow the fingerprint
  countSimulation | if set, use count simulation while generating the fingerprint
  includeChirality | if set, chirality information will be added to the generated bit id, independently from bond invariants
  onlyNonzeroInvariants | if set, bits will only be set from atoms that have a nonzero invariant
  countBounds | boundaries for count simulation, corresponding bit will be set if the count is higher than the number provided for that spot
  fpSize | size of the generated fingerprint, does not affect the sparse versions
  countSimulation | if set, use count simulation while generating the fingerprint
  includeChirality | sets includeChirality flag for both MorganArguments and the default bond generator MorganBondInvGenerator
  useBondTypes | if set, bond types will be included as a part of the default bond invariants
  onlyNonzeroInvariants | if set, bits will only be set from atoms that have a nonzero invariant
  includeRedundantEnvironments | if set redundant environments will be included in the fingerprint
  atomInvariantsGenerator | custom atom invariants generator to use
  bondInvariantsGenerator | custom bond invariants generator to use
  ownsAtomInvGen | if set atom invariants generator is destroyed with the fingerprint generator
  ownsBondInvGen | if set bond invariants generator is destroyed with the fingerprint generator

Returns
  FingerprintGenerator<OutputType>* that generates Morgan fingerprints

This generator supports the following `AdditionalOutput` types:

- `atomToBits` : which bits each atom is the central atom for
- `atomCounts` : how many bits each atom sets
- `bitInfoMap` : map from bitId to (atomId, radius) pairs

References RDKIT_FINGERPRINTS_EXPORT.

## ◆ getMorganGenerator() [3/3]

template<typename OutputType>

FingerprintGenerator< OutputType > * RDKit::MorganFingerprint::getMorganGenerator | ( | unsigned int | radius,
|  | bool | countSimulation = false,
|  | bool | includeChirality = false,
|  | bool | useBondTypes = true,
|  | bool | onlyNonzeroInvariants = false,
|  | AtomInvariantsGenerator * | atomInvariantsGenerator = nullptr,
|  | BondInvariantsGenerator * | bondInvariantsGenerator = nullptr,
|  | std::uint32_t | fpSize = 2048,
|  | std::vector< std::uint32_t > | countBounds = {1, 2, 4, 8},
|  | bool | ownsAtomInvGen = false,
|  | bool | ownsBondInvGen = false )

Get a fingerprint generator for Morgan fingerprint.

Template Parameters

  OutputType | determines the size of the bitIds and the result, can be 32 or 64 bit unsigned integer

Parameters

  radius | the number of iterations to grow the fingerprint
  countSimulation | if set, use count simulation while generating the fingerprint
  includeChirality | if set, chirality information will be added to the generated bit id, independently from bond invariants
  onlyNonzeroInvariants | if set, bits will only be set from atoms that have a nonzero invariant
  countBounds | boundaries for count simulation, corresponding bit will be set if the count is higher than the number provided for that spot
  fpSize | size of the generated fingerprint, does not affect the sparse versions
  countSimulation | if set, use count simulation while generating the fingerprint
  includeChirality | sets includeChirality flag for both MorganArguments and the default bond generator MorganBondInvGenerator
  useBondTypes | if set, bond types will be included as a part of the default bond invariants
  onlyNonzeroInvariants | if set, bits will only be set from atoms that have a nonzero invariant
  atomInvariantsGenerator | custom atom invariants generator to use
  bondInvariantsGenerator | custom bond invariants generator to use
  ownsAtomInvGen | if set atom invariants generator is destroyed with the fingerprint generator
  ownsBondInvGen | if set bond invariants generator is destroyed with the fingerprint generator

Returns
  FingerprintGenerator<OutputType>* that generates Morgan fingerprints

This generator supports the following `AdditionalOutput` types:

- `atomToBits` : which bits each atom is the central atom for
- `atomCounts` : how many bits each atom sets
- `bitInfoMap` : map from bitId to (atomId, radius) pairs

Definition at line 329 of file MorganGenerator.h.